"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class Result {
}
class Batcher {
    constructor() {
        this.batch = [];
        this.async = (asyncFn, dependencies = []) => {
            const result = new Result();
            result.promise = new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
                try {
                    yield Promise.all(dependencies.map((dependency) => dependency.promise));
                    const val = yield asyncFn(...dependencies);
                    result.value = val;
                    resolve(val);
                }
                catch (error) {
                    reject(error);
                }
            }));
            this.batch.push(result.promise);
            return result;
        };
        this.run = () => __awaiter(this, void 0, void 0, function* () {
            yield Promise.all(this.batch);
        });
    }
}
exports.default = Batcher;
//# sourceMappingURL=batcher.js.map